<%-- $Id: simple_export.jsp 7090 2016-03-03 11:54:59Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.Set"
	import="java.util.List"
	
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final ItemContext cc = sc.getCurrentContext(itemType, subContext);
final String defaultColumns = (String)cc.getObject("defaultColumns");
String errorMessage = (String)sc.getSessionSetting("plugin.configure.errors.message");
List<Throwable> errors = (List<Throwable>)sc.getSessionSetting("plugin.configure.errors.list");
%>
	<base:page type="popup" title="Export">
	<base:head scripts="/plugins/net/sf/basedb/clients/web/plugins/simple_export.js" />
	<base:body>
		<h1>Export options <base:help helpid="simpleexport.options" /></h1>
		
		<div id="page-data" class="datacontainer"
			data-default-columns="<%=HTML.encodeTags(defaultColumns)%>"
		></div>
		
		<form name="export" action="index.jsp" method="post">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="requestId" value="<%=request.getParameter("requestId")%>">
		<input type="hidden" name="cmd" value="SetParameters">
		<input type="hidden" name="item_type" value="<%=itemType.name()%>">
		<input type="hidden" name="subcontext" value="<%=subContext == null ? "" : subContext%>">
		
		<div class="content">
		
		<%
		if (errorMessage != null || (errors != null && errors.size() > 0))
		{
			%>
			<div id="errors" style="margin-bottom: 12px;" class="parameterhelp">
				<div class="messagecontainer error" style="margin: 0px;">
				<%=errorMessage %>
				</div>
				<%
				if (errors != null && errors.size() > 0)
				{
					%>
					<div id="showerrorlist" style="display: none;">
						<base:icon id="btnShowError" image="bullet.png">Show details</base:icon>
					</div>
					<div id="errorlist">
					<ol>
					<%
					for (Throwable t : errors)
					{
						%>
						<li><%=t.getMessage()%><br>
						<%
					}
					%>
					</ol>
					<base:icon id="btnHideError" image="bullet.png">Hide details</base:icon>
					</div>
					<%
				}
				%>
			</div>
			<%
		}
		%>
			<table class="fullform input100 bottomborder">
			<tr>
				<th style="height: 4em;">Format</th>
				<td>
					<input type="radio" name="parameter:format" id="formatText" value="text" checked
						><label for="formatText">Tab-separated text file</label><br>
						<span style="padding-left: 2em;">Separator for multi-valued columns:
						<input type="text" name="parameter:collectionSeparator" 
							id="collectionSeparator" value="," style="width: 3em;">
							
						<select name="collectionSeparatorPreset" id="collectionSeparatorPreset">
							<option value="">- presets -
							<option value=",">&nbsp;,
							<option value=";">&nbsp;;
							<option value="|">&nbsp;|
						</select>
						</span><br>
					<input type="radio" name="parameter:format" id="formatXml" value="xml"
						><label for="formatXml">XML</label><br>
				</td>
			</tr>
			<tr>
				<th style="height: 5em;">Which items?</th>
				<td>
					<input type="radio" name="parameter:whichItems" id="whichSelected" value="selected"
						><label for="whichSelected" id="lblSelected">Selected items</label><br>
					<input type="radio" name="parameter:whichItems" id="whichPage" value="page"
						><label for="whichPage" id="lblCurrentPage">Current page</label><br>
					<input type="radio" name="parameter:whichItems" id="whichAll" value="all" checked
						><label for="whichAll">All pages</label><br>
				</td>
			</tr>
			<tr class="big">
				<th>
					Which columns?<br>
					<select name="presets" id="presets">
						<option>
						<option value="all" title="Export all columns">All
						<option value="_current_" title="Export the currently visible columns" selected>Current
						<%
						if (defaultColumns != null)
						{
							%>
							<option value="_default_" title="Export the default visible columns">Default
							<%
						}
						Enumeration<Integer, String> contexts = sc.getContextNames(itemType, subContext);
						for (int i = 0; i < contexts.size(); ++i)
						{
							ItemContext context = sc.getContext(contexts.getKey(i));
							if (context != null && !ItemContext.DEFAULT_NAME.equals(context.getName()))
							{
								String columns = context.getSetting("columns");
								%>
								<option value="<%=columns%>"><%=HTML.encodeTags(context.getName())%>
								<%
							}
						}
						%>
					</select>
				</th>
				<td>
					<table style="width: 100%;">
					<tr>
						<td>
						<base:buttongroup vertical="true">
							<base:button
								id="moveUp"
								data-down="0"
								image="move_up.png" 
								tooltip="Move up" 
							/>
							<base:button 
								id="moveDown"
								data-down="1"
								image="move_down.png" 
								tooltip="Move down" 
							/>
						</base:buttongroup>
						</td>
						<td style="width: 50%;">
							<b>Exported columns</b><br>
							<select name="exported" id="exported" multiple size=10 style="width: 100%;"
								data-to="not_exported"
							</select>
						</td>
						<td style="padding-left: 2px;">
						<base:buttongroup vertical="true">
							<base:button
								id="moveLeft"
								data-from="not_exported"
								data-to="exported"
								image="move_left.png" 
								tooltip="Make the selected hidden column(s) visible" 
							/>
							<base:button 
								id="moveRight"
								data-from="exported"
								data-to="not_exported"
								image="move_right.png" 
								tooltip="Make the selected visible column(s) hidden" 
							/>
						</base:buttongroup>
						</td>
						<td style="width: 50%; padding-right: 0.5em;">
							<b>Not exported</b><br>
							<select name="not_exported" id="not_exported" multiple size=10 style="width: 100%;"
								data-to="exported" 
							</select>
						</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr>
				<th>Units</th>
				<td><input type="checkbox" name="sameUnits" id="sameUnits"
					value="true" checked><label for="sameUnits"
					>Use same unit for all annotations in a column</label></td>
			</tr>
			<tr>
				<th>Column prefix</th>
				<td>
					<input type="text" name="parameter:columnPrefix" 
						class="text" size="50" maxlength="255" value=""></td>
			</tr>
			<tr>
				<th>Save as</th>
				<td>
					<table style="width:98%;">
					<tr>
					<td style="width: 98%;"><input type="text" class="text" name="path" id="path" value="" placeholder="Leave empty to download immediately"></td>
					<td><base:button 
						id="btnBrowse"
						title="Browse..." />
					</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr>
				<th class="subprompt"></th>
				<td>
					<input type="checkbox" name="parameter:overwrite" id="overwrite" value="true">
						<label for="overwrite">Overwrite existing file</label>
				</td>
			</tr>
				
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
		</div>
		</form>
	
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnExport" title="Ok" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>

