<%-- $Id: edit_experiment.jsp 6387 2013-12-18 13:03:20Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.json.JsonUtil"
	import="net.sf.basedb.util.json.JsonConverter"
	import="net.sf.basedb.util.json.NameableConverter"
	import="java.util.Arrays"
	import="java.util.Date"
	import="java.util.List"
	import="org.json.simple.JSONArray"
	import="org.json.simple.JSONObject"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.EXPERIMENT;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String tabId = Values.getString(request.getParameter("tab"), null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Experiment experiment = null;
	RawDataType currentRawDataType = null;
	RawDataType defaultRawDataType = null;
	ItemQuery<RawBioAssay> rbaQuery = null;
	ItemQuery<AnnotationType> efQuery = null;
	
	boolean readCurrentDirectory = true;
	Directory currentDirectory = null;

	List<Directory> recentDirectories = (List<Directory>)cc.getRecent(dc, Item.DIRECTORY);

	int activeProjectId = sc.getActiveProjectId();
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);		
		defaultRawDataType = activeProject.getDefaultRawDataType();
	}	
	if (itemId == 0)
	{
		title = "Create experiment";
		currentRawDataType = RawDataTypes.getRawDataType(cc.getPropertyValue("rawDataType"));
		if (currentRawDataType == null)
		{
			currentRawDataType = RawDataTypes.getRawDataType(cc.getRecent("RawDataType", 0));
		}
		if (currentRawDataType == null) 
		{
			currentRawDataType = defaultRawDataType;
		}
		
		if (cc.getPropertyFilter("directory.name") != null)
		{
			currentDirectory = Base.getFirstMatching(dc, Directory.getQuery(), "name", cc.getPropertyFilter("directory.name"));
		}
		cc.removeObject("item");
		if (Values.getBoolean(request.getParameter("rawbioassays")))
		{
			rbaQuery = RawBioAssay.getQuery();
			rbaQuery.restrict(Restrictions.in(Hql.property("id"), Expressions.parameter("selected")));
			rbaQuery.setParameter("selected", sc.getCurrentContext(Item.RAWBIOASSAY).getSelected(), Type.INT);
		}

	}
	else
	{
		experiment = Experiment.getById(dc, itemId);
		experiment.checkPermission(Permission.WRITE);
		rbaQuery = experiment.getRawBioAssays();
		efQuery = experiment.getExperimentalFactors();
		cc.setObject("item", experiment);
		try
		{
			currentRawDataType = experiment.getRawDataType();
		}
		catch (Throwable t)
		{}
		title = "Edit experiment -- " + HTML.encodeTags(experiment.getName());
		try
		{
			currentDirectory = experiment.getDirectory();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentDirectory = false;
		}
	}
	
	// Load rawbioassays as JSON objects
	JSONObject jsonRawBioAssays = new JSONObject();
	jsonRawBioAssays.put("itemType", "RAWBIOASSAY");
	if (rbaQuery != null)
	{
		rbaQuery.include(Include.ALL);
		rbaQuery.order(Orders.asc(Hql.property("name")));
		List<RawBioAssay> rawBioAssays = rbaQuery.list(dc);
		
		if (rawBioAssays.size() > 0 && experiment == null) 
		{
			// Nullify so we can get raw data type from the raw bioassays
			currentRawDataType = null;
		
			for (RawBioAssay rba : rawBioAssays)
			{
				try
				{
					RawDataType rbaDataType = rba.getRawDataType();
					if (currentRawDataType == null) 
					{
						currentRawDataType = rbaDataType;
					}
					else if (rbaDataType != currentRawDataType)
					{
						throw new WebException("popup", "Raw data types doesn't match",
								"The raw data type of the selected raw bioassays are not the same. " + 
								"It is not possible to mix raw data types in an experiment.");
					}
				}
				catch (RuntimeException t)
				{}
			}
		}
		
		jsonRawBioAssays.put("items", JsonUtil.toArray(rawBioAssays, new NameableConverter()));
	}
	
	// Load experimental factors as JSON objects
	JSONObject jsonAnnotationTypes = new JSONObject();
	jsonAnnotationTypes.put("itemType", "ANNOTATIONTYPE");
	if (efQuery != null)
	{
		efQuery.include(Include.ALL);
		efQuery.order(Orders.asc(Hql.property("name")));
		jsonAnnotationTypes.put("items", JsonUtil.toArray(efQuery.iterate(dc), new NameableConverter()));
	}
	
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), experiment);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,linkitems-2.js,~experiments.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		
		<div id="page-data" class="datacontainer"
			data-current-raw-data-type="<%=currentRawDataType != null && experiment != null ? currentRawDataType.getId() : "" %>"
		></div>
		
		<form action="index.jsp?ID=<%=ID%>" method="post" name="experiment">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom" remember="<%=tabId == null && experiment != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Experiment" helpid="experiment.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=experiment == null ? "focus-select" : "focus" %>" 
					type="text" name="name" 
					value="<%=HTML.encodeTags(experiment == null ? Values.getString(cc.getPropertyValue("name"), "New experiment") : experiment.getName())%>" 
					maxlength="<%=Experiment.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Raw data type</th>
				<td>
					<%
					if (experiment == null)
					{
						currentRawDataType = currentRawDataType != null ? 
							currentRawDataType : defaultRawDataType;
						Enumeration<RawDataType, String> rawEnumeration = 
							new Enumeration<RawDataType, String>();
						for (RawDataType rdt : RawDataTypes.getRawDataTypes())
						{
							rawEnumeration.add(rdt, rdt.getName());
						}
						rawEnumeration.sortValues();						
						%>
						<select name="rawdatatype" class="required unchangeable">
						<%
						for (int i = 0; i < rawEnumeration.size(); ++i)
						{
							RawDataType rdt = rawEnumeration.getKey(i);
							String selected = rdt.equals(currentRawDataType) ? "selected" : "";
							%>
							<option value="<%=rdt.getId()%>" <%=selected%>><%=HTML.encodeTags(rdt.getName())%>
							<%
						}
						%>
						</select>
						<%
					}
					else
					{
						%>
						<base:catch><%=HTML.encodeTags(experiment.getRawDataType().getName())%></base:catch>
						<%
					}
					%>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Directory</th>
				<td>
					<base:select 
						id="directory_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentDirectory%>"
						denied="<%=!readCurrentDirectory%>"
						recent="<%=recentDirectories%>"
						newitem="<%=experiment == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr >
				<th>Raw bioassays</th>
				<td>
					<div class="selectionlist">
					<table>
					<tr>
						<td>
						<select name="rawBioAssays" id="rawBioAssays" 
							class="auto-init"
							data-auto-init="link-container"
							data-initial-items="[<%=HTML.encodeTags(jsonRawBioAssays.toJSONString()) %>]"
							data-initial-action="<%=itemId == 0 ? 1 : 0 %>"
							size="5" multiple>
						</select>
						</td>
						<td style="vertical-align: top;">
							<base:buttongroup vertical="true">
								<base:button 
									id="btnAddRawBioAssays"
									subclass="leftaligned"
									style="width: 14em;"
									title="Add&nbsp;raw bioassays&hellip;" 
									tooltip="Add raw bioassays"
								/>
								<base:button 
									id="btnRemoveRawBioAssays"
									subclass="leftaligned auto-init"
									data-auto-init="remove-link"
									data-list-id="rawBioAssays"
									style="width: 14em;"
									title="Remove" 
									tooltip="Remove the selected raw bioassays"
								/>
							</base:buttongroup>
						</td>
					</tr>
					</table>
					</div>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="4" name="description" id="description"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("description") : experiment.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
			
		</t:tab>
		
		<t:tab id="publication" title="Publication"  helpid="experiment.edit.publication">
			<table class="fullform input100">
			<tr>
				<th>PubMedId</th>
				<td><input class="text" type="text" name="pubMedId" 
					value="<%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("pubMedId") : experiment.getPubMedId())%>" 
					maxlength="<%=Experiment.MAX_PUBMEDID_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Title</th>
				<td>
					<textarea class="text" rows="4" name="title" id="title"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("title") : experiment.getTitle())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="title" title="Title" />
				</td>
			</tr>
			<tr>
				<th>Publication date</th>
				<td>
					<table>
					<tr>
					<td>
						<input class="text" style="width: 15em;" type="text" name="publicationDate" id="publicationDate"
							value="<%=HTML.encodeTags(dateFormatter.format(experiment == null ? 
								(Date)cc.getPropertyObject("publicationDate") : experiment.getPublicationDate()))%>" 
							maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
					</td>
					<td>
						<base:calendar textarea="publicationDate" title="Publication date" />
					</td>
					</tr>
					</table>					
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Abstract</th>
				<td>
					<textarea class="text" rows="4" name="abstract" id="abstract"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("abstract") : experiment.getAbstract())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="abstract" title="Abstract" />
				</td>
			</tr>
			<tr>
				<th>Experiment design</th>
				<td>
					<textarea class="text" rows="4" name="experimentDesign" id="experimentDesign"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("experimentDesign") : experiment.getExperimentDesign())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="experimentDesign" title="Experiment design" />
				</td>
			</tr>
			<tr>
				<th>Experiment type</th>
				<td>
					<textarea class="text" rows="4" name="experimentType" id="experimentType"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("experimentType") : experiment.getExperimentType())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="experimentType" title="Experiment type" />
				</td>
			</tr>
			<tr>
				<th>Affiliations</th>
				<td>
					<textarea class="text" rows="4" name="affiliations" id="affiliations"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("affiliations") : experiment.getAffiliations())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="affiliations" title="Affiliations" />
				</td>
			</tr>
			<tr>
				<th>Authors</th>
				<td>
					<textarea class="text" rows="4" name="authors" id="authors"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("authors") : experiment.getAuthors())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="authors" title="Authors" />
				</td>
			</tr>
			<tr>
				<th>Publication</th>
				<td>
					<textarea class="text" rows="4" name="publication" id="publication"
						><%=HTML.encodeTags(experiment == null ? cc.getPropertyValue("publication") : experiment.getPublication())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="publication" title="Publication" />
				</td>
			</tr>
			</table>
			</t:tab>
			
			<t:tab id="experimentalFactors" title="Experimental factors" helpid="experiment.edit.factors">
			<table class="fullform input100">
			<tr class="big">
				<th>Annotation types</th>
				<td>
					
					<div class="selectionlist">
					<table>
					<tr>
						<td>
						<select name="annotationTypes" id="annotationTypes"
							class="auto-init"
							data-auto-init="link-container"
							data-initial-items="[<%=HTML.encodeTags(jsonAnnotationTypes.toJSONString()) %>]"
							size="20" multiple>
						</select>
						</td>
						<td style="vertical-align: top;">
							<base:buttongroup vertical="true">
								<base:button 
									id="btnAddAnnotationTypes"
									subclass="leftaligned auto-init"
									data-auto-init="add-link"
									data-list-id="annotationTypes"
									data-item-type="ANNOTATIONTYPE" 
									style="width: 14em;"
									title="Add annotation types&hellip;" 
									tooltip="Add annotation types"
									/>
								<base:button 
									id="btnRemoveAnnotationTypes"
									subclass="leftaligned auto-init"
									data-auto-init="remove-link"
									data-list-id="annotationTypes"
									style="width: 14em;"
									title="Remove" 
									tooltip="Remove the selected annotation types"
								/>
							</base:buttongroup>
						</td>
					</tr>
					</table>
					</div>
				</td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
			</t:tab>
			
		<t:tab id="annotations" title="Annotations" helpid="annotations.edit">
			<jsp:include page="../../common/annotations/annotate_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>

		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
			<%if (experiment == null) {%><br>
				<base:icon image="unchangeable.png" />= can't be changed later
			<%}%>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
